
#ifndef __STATIONUCGO_H
#define __STATIONUCGO_H

#define VERSION_MAJOR	3
#define VERSION_MINOR	0
#define VERSION_BUILD	0
#define	lita(arg) #arg
#define	xlita(arg) lita(arg)
#define	cat3(w,x,z) w##.##x##.##z##\000
#define	xcat3(w,x,z) cat3(w,x,z)
#define	VERSION_STRING xlita(xcat3 (VERSION_MAJOR,VERSION_MINOR,VERSION_BUILD))

#ifndef	VS_VERSION_INFO
#define	VS_VERSION_INFO		0x0001
#endif

#define DEFAULT_MAX_CREW 3
#define DEFAULT_MAX_EVA 1
#define CONTROL_MENU_UMMU "MMU Keys: 1,2=Select UMmu  A=Open/Close Airlock  E=EVA  M=Add Crew  5=Show UMMU Keys  7=MMU Info  -/= Select Active EVA Dock"
#define CONTROL_MENU_UCGO "Cargo Keys: 3,4=Select Cargo Slot  C/SHF+C=Grapple/Release  9/SHF+9=Add Cargo  6=Show UCGO Keys  8=Cargo Info"
#define AIRLOCK_ACTION_AREA 0

HINSTANCE g_hDLL;

class StationUCGO: public VESSEL3 {
public:
	StationUCGO (OBJHANDLE hObj, int fmodel): VESSEL3(hObj, fmodel) {}
	~StationUCGO () {}

	void clbkLoadStateEx(FILEHANDLE scn, void *status);
	void clbkSaveState(FILEHANDLE scn);
	void clbkSetClassCaps(FILEHANDLE cfg);
	void clbkPostStep (double simtt, double simdt, double mjd);
	bool clbkLoadGenericCockpit(void);
	void clbkRenderHUD(int mode, const HUDPAINTSPEC *hps, SURFHANDLE hDefaultTex);
	bool clbkDrawHUD(int mode, const HUDPAINTSPEC *hps, oapi::Sketchpad *skp);
	int clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
	void SetUMMUAirlockPos(void);

	// UMMU 3.0 Declarations
	UMMUCREWMANAGMENT Crew;
	char cUmmuHudDisplay[255];						// UMmu hud char variable
	double dUMMUHudMessageDelay;					// UMmu hud display delay
	char *SendUMMUHudMessage(void);					// UMmu hud display function
	char cAddUMmuToVessel[255];
	void AddUMmuToVessel(BOOL bStartAdding = FALSE);
	void UMMU_Init(FILEHANDLE cfg);

	// UCGO 3.0 Declarations
	UCGO	hUcgo;						// Cargo class handle
	char   *SendUCGOHudMessage(void);	// Cargo hud display function
	char	cUCGOHudDisplay[255];		// Cargo hud display char variable
	double	dUCGOHudMessageDelay;		// Cargo hud display delay
	void UCGO_Init(FILEHANDLE cfg);

private:
	bool ShowDefaultHUD;
	int MaxUmmuSeats;				// Max number of MMU allowed in the station
	int MaxCargoSlots;
	int MaxEVASpots;				// Max number of egress/ingress points for this vessel
	double MaxCargoMass;
	int SelectedUmmuMember;
	int SelectedCargoSlot;
	float x_pos[4], z_pos[4];		// EVA positions for the multiple dock points
									// Limited to 4 such points for ease of getting this update out
	int ActiveDockNumber;			// To allow for multiple dock points per vessel
	VECTOR3 CameraVector[4];		// Magnitude of vector for each dock point so we don't have to recalc all the time
	bool CameraSwitchPending;		// To allow once-only camera direction update so user can still pan

};

#endif
